using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;
using UnityEngine.UIElements;
public enum ModeEnum//ģʽö
{
    autofill = 0,//Զ
    fixedSize = 1,//̶С
}
public class BoxTypeItem//עᴰ
{
    public int type;//
    public string title = "Դ";//
    public string content = "Դ";//
    public string hint = "Դʾ";//ʾ
}
public class NormalPopUpWindow : MonoBehaviour
{
    public void setMode(ModeEnum modeEnum)
    {
        Mode = modeEnum;
        switch (modeEnum)
        {
            case ModeEnum.autofill://Զ
                contentList.GetComponent<ContentSizeFitter>().verticalFit = ContentSizeFitter.FitMode.MinSize;
                viewport.GetComponent<VerticalLayoutGroup>().enabled = true;
                viewport.GetComponent<VerticalLayoutGroup>().childControlHeight = true;
                scroll_view.GetComponent<ScrollRect>().horizontal = false;
                scroll_view.GetComponent<ScrollRect>().vertical = false;
                viewport.GetComponent<LayoutElement>().minHeight = minimumHeight;
                scroll_view.GetComponent<LayoutElement>().minHeight = minimumHeight;
                break;
            case ModeEnum.fixedSize://̶С
                contentList.GetComponent<ContentSizeFitter>().verticalFit = ContentSizeFitter.FitMode.MinSize;
                viewport.GetComponent<VerticalLayoutGroup>().enabled = false;
                viewport.GetComponent<VerticalLayoutGroup>().childControlHeight = false;
                scroll_view.GetComponent<ScrollRect>().horizontal = false;
                scroll_view.GetComponent<ScrollRect>().vertical = true;
                viewport.GetComponent<LayoutElement>().minHeight = minimumHeight;
                scroll_view.GetComponent<LayoutElement>().minHeight = minimumHeight;
                break;
        }
    }
    public ModeEnum Mode = ModeEnum.autofill;//ģʽ
   
    public void setMinimumHeight(int value) {
        minimumHeight = value;
        this.GetComponent<LayoutElement>().minHeight = minimumHeight;
        viewport.GetComponent<LayoutElement>().minHeight = minimumHeight;
        scroll_view.GetComponent<LayoutElement>().minHeight = minimumHeight;
        Debug.Log(GetComponent<LayoutElement>().minHeight);
    }
    private int minimumHeight = -1;//С߶
    public void setMinimumWidth(int value)
    {
        minimumWidth = value;
        GetComponent<LayoutElement>().minWidth = minimumWidth;
        Debug.Log(GetComponent<LayoutElement>().minWidth);
    }
    private int minimumWidth = -1;//С

    public GameObject Title;//ڱ
    public GameObject contentList;//ݶ
    public GameObject viewport;//Ӵ
    public GameObject scroll_view;//ڻ


    private List<GameObject> gameObjects = new List<GameObject>();//עȫ
    public List<GameObject> newPopup(List<BoxTypeItem> my_boxTypes, string title = "")//ui·
    {
        List<GameObject> gameObjectitem = new List<GameObject>();
        Title.GetComponent<Text>().text = title;
        float posY = 0;
        foreach (BoxTypeItem boxType in my_boxTypes)
        {
            GameObject gameObject = AddItem(boxType);
            gameObjects.Add(gameObject);
            gameObjectitem.Add(gameObject);
            posY += gameObject.GetComponent<RectTransform>().sizeDelta.y;

        }
        //scroll_view.GetComponent<ScrollRect>().verticalNormalizedPosition = 1.0f;
        return gameObjectitem;
    }

    private GameObject AddItem(BoxTypeItem boxType)
    {
        GameObject ranking_list_item = null;
        switch (boxType.type)
        {
            case 0:
                ranking_list_item = Instantiate(popUpsCanvas.popUpsCanvasobj.singleButton, GameObject.Find("Content").transform);
                break;
            case 1:
                ranking_list_item = Instantiate(popUpsCanvas.popUpsCanvasobj.inputBoxWithButton, GameObject.Find("Content").transform);
                break;
        }
       
        ranking_list_item.GetComponent<PopUpWindowitem>().UpdateBoxTypeItem(boxType);
        return ranking_list_item;
    }
}
